;{ options
Structure StOption ; les options d'affichage de l'diteur
  Grid.a : Marker3D.a : Bbox.a : Lang$
  WorldShadow.a : LightActive.a
  CameraRenderMode.a
  ViewZoom.a
  confirmExit.a : autosize.a : tooltip.a
  WinW.w : WinH.w
  axeMouse.a : ModeSelection.a : autoShadow.a : autodir.a
  OldUi.a
EndStructure
Global option.StOption
;}

;{ utile, vector.
Structure Vector3
  X.w : Y.w : Z.w
EndStructure
;}

;{ UI
Structure StCible; une cible, pour crer un objet3D  l'endroit de celle-ci
  Pos.Vector3
  Show.a
EndStructure
Global Cible.StCible

Structure StProgram; donnes lies au programme en gnral (par exemple, les prfrences)
  
EndStructure
Global Program.StProgram
;}

;{ objet 3D

;{ assets
Structure StAsset ; les objets 3D de base (dcors, arbres..)
  ; je dois supprimer cette structure car elle fait doublon avec la structure StObject3D 
  ; mais pour le moment, je la garde car je m'en sers avec la nouvelle interface (treegadget et propertybox)
  ;{ general
  names$ : type.a
  ;}
  ;{ 2D
  sprite.w
  ;}  
  ;{ 3D mesh, material 
  meshname$ : meshId.w
  material$ : matId.w
  ;}
  ;{ transformation
  dimension.Vector3
  pos.Vector3
  rot.Vector3
  scale.Vector3
  ;}
  ;{ editor
  block.a : hide.a : lookTo.a
  id.w
  ;}
  ;{ motion  
  ;}
  ;{ light
  colDif.i : colSpec.i
  ;}
EndStructure
Global NewList Asset.stAsset()
;}

; bibliotheque generale
Structure StBibliotheque
  ; c'est la bibliotheque dans laquelle on stocke les objets et autres assets dj utiliss (texture, material, mesh,..) ainsi que le nombre d'entity
  Name$ 
  ;{ type
  Type.a 
    ; les objet (import avec mesh + material)
  ; 0 = object3D
  
  ; objet de cration pour le terrain, ou le ciel
  ; 50 = water (createwaterr())
  ; 51 = terrain (cr avec (createterrain())
  ; 52 = skydom
  ; 53 = skybox
  
  ; Objet d'action
  ; 60 = teleporteur (pour changer de level/map/scene)
  ; 61 = coffre
  
  ; Obstacle ou objet physique
  ; 80 = obstacle (objet bloquant, ne peut pas bouger, ni tre cass)
  ; 81 = obstacle bloquant physique, qu'on peut bouger
  ; 82 = objet physique cassable
  
  ; Light
  ; 100 = light
  
  ; FX, particules
  ; 110 = FX
  ; 111 = systme de particule (avec billboard ?)
  
  ; Character, NPC (PNJ)
  ; 130 = PNJ
  ; 131 = monster

  ;}
  ;{ infos de mesh, material, entit..
  Dir$
  MeshId.w : TextureId.w : MaterialId.w : ObjetId.w
  MeshName$ : TextureName$ : MaterialName$
  Center.w
  ;}
EndStructure
; on peut utiliser des pointeurs pour a , mais pour tout simplifier, j'ai utilis des globales.
Global NewList bibli.StBibliotheque(); la bibliotheque d'asset  enregistrer pour ne pas charger 2 fois le mme asset
Global obj.StBibliotheque; pour stocker les paramtres slectionns


; pour les materials/ shaders
Structure StBibli_Mat  
  TextureId.w : MaterialId.w
  MeshName$ : TextureName$ : MaterialName$
EndStructure
Global NewList bibli_mat.StBibli_Mat(); la bibliotheque d'asset  enregistrer pour ne pas charger 2 fois le mme asset


Structure StObject3D Extends StBibliotheque
  ; structure pour tous les objets de la scene, on les pilotera via la liste object(), 
  ; c'est pas top rapide, mais a marche pour un diteur (pour le moment)., et a a l'avantage d'tre hyper mga simple.
  ;{ pos, rot, size
  Size.d : Pos.Vector3 : Rot.Vector3 : scale.Vector3
  ;}
  ;{ graphiques, affichage
  Hide.a : CastShadow.a : ReceiveShadow.a 
  blendmode.a : selectMode.a
  ;}
  ;{ object
  EntityId.w : Selected.a : blocked.a : TypeObjet.a; par rapport  la variable TypeObjet
  ;}
  ;{ light
   Color.i : ColorSpec.i : Shadow.a : LightType.a
   ;}
  ;{ water
  transparency.a
  flag.i[6]; the options for the water
  ;}
  ;{ fx
  ;}  
EndStructure
Global GbEntity.StObject3D; a c'est pour connaitre l'entity active.
GbEntity\Size = 2
Global NewList object.StObject3D(); la liste de tous les objets dans notre scne (light, entity, etc..)
Global NewList object_temp.StObject3D(); ncessaire lorsque j'ouvre un fichier par exemple


;{ pas utilis
; les listes d'objets : objet3D, light, particules, terrain, water, camera
; je ne m'en sers pas
Structure StList
  List Obj.StObject3D()
EndStructure
;Global Dim liste.StList(6)

; pour changer d'objet, on utilise la varaible globale : TypeObjet
; TypeObjet -> 0 : objet3D, 1 : light, 2 : particules, 3 : terrain, 4 :water, 5:camera
; par exemple, pour cacher tous les objets 3D :
; TypeObjet = 0
; ForEach liste(TypeObjet)\obj()
;   liste(TypeObjet)\obj()\hide = 1
; Next 
;}

;}

;{ primitive
Structure Stprimitive ; pour les primitives (sphere, plane, cube)
  TexturRepeat.w
EndStructure
Global prim.Stprimitive
;}

;{ world
Structure StFog
  actif.a : StarDist.w : EndDist.w
  Intensity.d : Color.i
EndStructure

Structure StSkydom ; et skybox
  SkyOk.a
  SkyImg$
  SkyCurve.w
EndStructure

Structure StSun
  X.w : y.w : z.w
  color.i
EndStructure

Structure StWorld
  ShadowType.a : ShadowDistance.w
  AmbientColor.i
  Fog.StFog 
  Skydom.StSkydom
  Skybox.StSkydom
  Sun.StSun
EndStructure
Global world.StWorld
;}

;{ camera
Structure Stcamera
  Id.a : name$
  pos.Vector3 : rot.Vector3 : view.a
  LookAt.a : LookatX.w : lookatY.w
  Axe.a
  SnapOk.a : Snap.Vector3
  ScaleOk.a : MeshScale.a
  SelectEntity.a
  Color.i
  FactorMove.d
EndStructure
Global camera.Stcamera
;}

;{ level
Structure StSceneTree; ncessaire pour stocker les lments du treegadget
  name$
EndStructure
Global Dim SceneTree.StSceneTree(12)

Structure StLevel; le level
    ; 3D
  NbMesh.w
  NbLight.w
  NbTexture.w
  NbMaterial.w
  NbPolyMax.w
   ; 2D
  NbSprite.w
  ; general
  NbObjet.w
  NbEntity.w
  Name$
  Dir$
EndStructure
Global Level.StLevel
;}

; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 223
; Folding = AAAA-
; EnableXP
; EnableOnError
; EnablePurifier